-- DejaBars
-- 12x1, 6x2, 4x3, 3x4, 2x6, 1x12
local _, private = ...
	private.defaults.dvdefaults.mbarsSetPoints = {
		point = "BOTTOM", 
		relativeTo = "dvlockcheckframe", 
		relativePoint = "BOTTOM", 
		xOffset = 0, 
		yOffset = 0,
	}
	private.defaults.dvdefaults.mbarBottomLeftSetPoints = {
		point = "BOTTOMLEFT", 
		relativeTo = "ActionButton1", 
		relativePoint = "TOPLEFT", 
		xOffset = 0, 
		yOffset = 6,
	}	
	private.defaults.dvdefaults.mbarBottomRightSetPoints = {
		point = "BOTTOMLEFT", 
		relativeTo = "MultiBarBottomLeftButton1", 
		relativePoint = "TOPLEFT", 
		xOffset = 0, 
		yOffset = 6,
	}	
	private.defaults.dvdefaults.petSetPoints = {
		point = "BOTTOMLEFT", 
		relativeTo = "MultiBarBottomRightButton1", 
		relativePoint = "TOPLEFT", 
		xOffset = 0, 
		yOffset = 6,
	}	
	private.defaults.dvdefaults.stanceSetPoints = {
		point = "BOTTOMLEFT", 
		relativeTo = "MultiBarBottomRightButton1", 
		relativePoint = "TOPLEFT", 
		xOffset = 0, 
		yOffset = 44,
	}
	private.defaults.dvdefaults.rightsidebarsSetPoints = {
		point = "BOTTOMRIGHT", 
		relativeTo = "Minimap", 
		relativePoint = "BOTTOMLEFT", 
		xOffset = 0, 
		yOffset = 0,
	}
	private.defaults.dvdefaults.micromenuSetPoints = {
		point = "BOTTOMRIGHT", 
		relativeTo = "Minimap", 
		relativePoint = "TOPRIGHT", 
		xOffset = 0, 
		yOffset = 0,
	}
	private.defaults.dvdefaults.bagsSetPoints = {
		point = "BOTTOMRIGHT", 
		relativeTo = "dvrsbframe", 
		relativePoint = "BOTTOMLEFT", 
		xOffset = 0, 
		yOffset = 0,
	}

-- Main Menu Bars

--Hide Main Bar Art
		MainMenuBarArtFrame:EnableMouse(false)

		MainMenuBarArtFrame:EnableMouse(false)

		MainMenuBarArtFrame.LeftEndCap:Hide()
		MainMenuBarArtFrame.RightEndCap:Hide()

		MainMenuBarArtFrameBackground:Hide()

		-- MainMenuBarTexture0:Hide()
		-- MainMenuBarTexture1:Hide()
		-- MainMenuBarTexture2:Hide()
		-- MainMenuBarTexture3:Hide()	
		
		-- MainMenuMaxLevelBar0:Hide()
		-- MainMenuMaxLevelBar1:Hide()
		-- MainMenuMaxLevelBar2:Hide()
		-- MainMenuMaxLevelBar3:Hide()

		StanceBarLeft:SetAlpha(0)
		StanceBarMiddle:SetAlpha(0)
		StanceBarRight:SetAlpha(0)

		SlidingActionBarTexture0:SetAlpha(0)
		SlidingActionBarTexture1:SetAlpha(0)	 
		
		-- ExhaustionLevelFillBar:Hide()
		-- MainMenuXPBarTextureLeftCap:Hide()
		-- MainMenuXPBarTextureRightCap:Hide()
		-- MainMenuXPBarTextureMid:Hide()
		
		-- MainMenuBarMaxLevelBar:Hide()

		-- MainMenuMaxLevelBar0:Hide()
		-- MainMenuMaxLevelBar1:Hide()
		-- MainMenuMaxLevelBar2:Hide()
		-- MainMenuMaxLevelBar3:Hide()
		
		CastingBarFrame.Border:SetTexture(nil);
		CastingBarFrame.Flash:SetTexture(nil);
		CastingBarFrame.Icon:Show();
		CastingBarFrame.Text:ClearAllPoints();	
		CastingBarFrame.Text:SetPoint("CENTER",CastingBarFrame,"CENTER",0,0);
		
		TargetFrameSpellBar.Border:SetTexture(nil);
		TargetFrameSpellBar.Flash:SetTexture(nil);
		TargetFrameSpellBar.Icon:Show();
		TargetFrameSpellBar.Text:ClearAllPoints();	
		TargetFrameSpellBar.Text:SetPoint("CENTER",TargetFrameSpellBar,"CENTER",0,0);
		
		FocusFrameSpellBar.Border:SetTexture(nil);
		FocusFrameSpellBar.Flash:SetTexture(nil);
		FocusFrameSpellBar.Icon:Show();
		FocusFrameSpellBar.Text:ClearAllPoints();	
		FocusFrameSpellBar.Text:SetPoint("CENTER",FocusFrameSpellBar,"CENTER",0,0);
		
--Hide XP Bar Art
	for i = 1, 19 do
		local texture = _G["MainMenuXPBarDiv"..i]
			if texture then
				texture:SetAlpha(0)
		end
	end
	
	
-- DV DragFrameTemplate
local function DragFrameTemplate(frame,frameGlobalName,frameParentFrame,frameWidth,frameHeight,dbTemplateDefaults)

		frame=CreateFrame("Frame", frameGlobalName, frameParentFrame)
		frame:SetFrameStrata("HIGH")
		frame:SetClampedToScreen(true)
		frame:SetMovable(true)
		frame:EnableMouse(true)
		frame:RegisterForDrag("LeftButton")
		frame:SetWidth(frameWidth)
		frame:SetHeight(frameHeight)
		frame:Show()
		

	local dbpoints = dbTemplateDefaults
		--print(dbpoints.point,dbpoints.relativeTo,dbpoints.relativePoint,dbpoints.xOffset,dbpoints.yOffset)--Debugging
		frame:ClearAllPoints()		
		frame:SetPoint(
			dbpoints.point, 
			dbpoints.relativeTo, 
			dbpoints.relativePoint, 
			dbpoints.xOffset, 
			dbpoints.yOffset)
		
		frame:SetScript("OnDragStart", frame.StartMoving) 
		
		frame:SetScript("OnDragStop", function(self) 
			self:StopMovingOrSizing() 
			self:SetUserPlaced(false) 
			
			point, relativeTo, relativePoint, xOfs, yOfs = self:GetPoint(1)
				if ( relativeTo ) then
					relativeTo = relativeTo:GetName();
				else
					relativeTo = self:GetParent():GetName();
				end
		
			-- These are debugging messages for the frame points
			-- Un-comment them to help debug
			-- DEFAULT_CHAT_FRAME:AddMessage(point)
			-- DEFAULT_CHAT_FRAME:AddMessage(relativeTo)
			-- DEFAULT_CHAT_FRAME:AddMessage(relativePoint)
			-- DEFAULT_CHAT_FRAME:AddMessage(xOfs)
			-- DEFAULT_CHAT_FRAME:AddMessage(yOfs)

			dbpoints.point = point
			dbpoints.relativeTo = relativeTo
			dbpoints.relativePoint = relativePoint
			dbpoints.xOffset = xOfs
			dbpoints.yOffset = yOfs
		print(dbpoints.point,dbpoints.relativeTo,dbpoints.relativePoint,dbpoints.xOffset,dbpoints.yOffset)--Debugging
			
		end)

	local frameFS = frame:CreateFontString("FontString","OVERLAY","GameTooltipText")

		frameFS:SetPoint("CENTER",frame,"CENTER",0,0)
		frameFS:SetFont("Fonts\\FRIZQT__.TTF", 10, "THINOUTLINE")
		frameFS:SetText(""..frameGlobalName);
		frameFS:SetTextColor(1, 1, 1);
		
		local dragTexture=frame:CreateTexture(nil,"ARTWORK")
		dragTexture:SetAllPoints(frame)
		dragTexture:SetColorTexture(0, 192, 255, 0.7)
end

local function move(frame,anchorPoint,relativeTo,relativePoint,xoff,yoff)
	frame:ClearAllPoints()
	frame:SetPoint(anchorPoint,relativeTo,relativePoint,xoff,yoff)
end	
	--	DragFrameTemplate reference:
	--		DragFrameTemplate(frame,frameGlobalName,frameParentFrame,frameWidth,frameHeight)
local DragFrameTemplateEventFrame=CreateFrame("Frame")
	DragFrameTemplateEventFrame:RegisterEvent("PLAYER_LOGIN")
	
		DragFrameTemplateEventFrame:SetScript("OnEvent", function(self, event, arg1)
			if event == "PLAYER_LOGIN" then
				-- DVMainBarFrame to center the main bar on
				DragFrameTemplate(mbars,"mbars",dvlockcheckframe,476,36, private.db.dvdefaults.mbarsSetPoints)
				move(ActionButton1,"BOTTOMLEFT",StatusTrackingBarManager,"BOTTOMLEFT",0,3)
					-- Action Bar Up/Down buttons
					move(MainMenuBarArtFrame.PageNumber,"CENTER",mbars,"CENTER",0,0)
					ActionBarUpButton:Hide()
					ActionBarDownButton:Hide()

				-- DVPetFrame
				-- 10x1, 5x2, 2x5, 1x10
				DragFrameTemplate(dvpetframe,"dvpetframe",dvlockcheckframe,318,38, private.db.dvdefaults.petSetPoints)
				move(PetActionButton1,"BOTTOMLEFT", dvpetframe, "BOTTOMLEFT", 0, 0)

				-- DVRightSideBarsFrame
				DragFrameTemplate(dvrsbframe,"dvrsbframe",dvlockcheckframe,191,121, private.db.dvdefaults.rightsidebarsSetPoints)
				move(MultiBarRightButton12,"BOTTOMRIGHT", dvrsbframe, "BOTTOMRIGHT", 0, 0)

				-- DVMBarBottomLeftFrame
				DragFrameTemplate(dvmbarBottomLeftframe,"dvmbarBottomLeftframe",dvlockcheckframe,476,36, private.db.dvdefaults.mbarBottomLeftSetPoints)
				move(MultiBarBottomLeftButton1,"BOTTOMLEFT",dvmbarBottomLeftframe,"BOTTOMLEFT",0,0)

				-- DVMBarBottomRightFrame
				DragFrameTemplate(dvmbarBottomRightframe,"dvmbarBottomRightframe",dvlockcheckframe,476,36, private.db.dvdefaults.mbarBottomRightSetPoints)
				move(MultiBarBottomRightButton1,"BOTTOMLEFT",dvmbarBottomRightframe,"BOTTOMLEFT",0,0)

				-- DVStanceFrame
				DragFrameTemplate(dvstanceframe,"dvstanceframe",dvlockcheckframe,190,38, private.db.dvdefaults.stanceSetPoints)
				move(StanceButton1,"BOTTOMLEFT", dvstanceframe, "BOTTOMLEFT", 0, 0)

				-- Position anchor buttons for each bar
				move(MultiBarLeftButton12,"BOTTOMRIGHT", MultiBarRightButton4, "BOTTOMLEFT", 0, 0)

				-- Anchor buttons 2-12 for each bar
				for _,bar in pairs({"ActionButton","MultiBarBottomLeftButton","MultiBarBottomRightButton"}) do
					for i=1,12 do
						v =_G[bar..i]
					end
					for i=2,12 do
						move(_G[bar..i],"LEFT",_G[bar..(i-1)],"RIGHT",4,0)
					end
				end

				-- Anchor buttons for right side bars
				for _,bar in pairs({"MultiBarRightButton","MultiBarLeftButton"}) do
					for i=1,12 do
						v =_G[bar..i]
						v:SetScale(0.84)
						v:SetFrameStrata("BACKGROUND")

					end
					for i=11,9, -1 do
						move(_G[bar..i],"BOTTOM",_G[bar..(i+1)],"TOP",0,0)
					end
					for i=8,5, -1 do
						move(_G[bar..i],"BOTTOM",_G[bar..(i+1)],"TOP",0,0)
					end
					for i=4,1, -1 do
						move(_G[bar..i],"BOTTOM",_G[bar..(i+1)],"TOP",0,0)
					end
					for i=8,4, -4 do
						move(_G[bar..i],"RIGHT",_G[bar..(i+4)],"LEFT",0,0)
					end
				end

				-- Anchor buttons 2-10 for Pet Action bar
				for _,bar in pairs({"PetActionButton"}) do
					for i=2,10 do
						move(_G[bar..i],"LEFT",_G[bar..(i-1)],"RIGHT",2,0)
					end
				end

				-- Anchor buttons 2-10 for Stance bar
				for _,bar in pairs({"StanceButton"}) do
					for i=2,10 do
						move(_G[bar..i],"LEFT",_G[bar..(i-1)],"RIGHT",2,0)
					end
				end
				end
		end)

-- DVMicroMenuFrame
local dvmmframe=CreateFrame("Frame", "dvmmframe", dvlockcheckframe)
	dvmmframe:RegisterEvent("PLAYER_LOGIN")
	dvmmframe:RegisterEvent("PLAYER_REGEN_ENABLED")
	dvmmframe:RegisterEvent("PLAYER_REGEN_DISABLED")
	dvmmframe:RegisterEvent("CINEMATIC_START")
	dvmmframe:RegisterEvent("CINEMATIC_STOP")
	dvmmframe:RegisterEvent("PET_BATTLE_OVER")
	dvmmframe:SetFrameStrata("HIGH")
	dvmmframe:SetClampedToScreen(true)
	dvmmframe:SetMovable(true)
	dvmmframe:EnableMouse(true)
	dvmmframe:RegisterForDrag("LeftButton")
	dvmmframe:SetWidth(310)
	dvmmframe:SetHeight(36)
	dvmmframe:Show()
	
	dvmmframe:SetScript("OnEvent", function(self, event, arg1)
		if event == "PET_BATTLE_OVER" then
			CharacterMicroButton:ClearAllPoints()
			CharacterMicroButton:SetPoint("BOTTOMLEFT",dvmmframe,"BOTTOMLEFT",27,-1)			
		else
			local point = private.db.dvdefaults.micromenuSetPoints
			self:ClearAllPoints()		
			self:SetPoint(
			point.point, 
			point.relativeTo, 
			point.relativePoint, 
			point.xOffset, 
			point.yOffset)
			CharacterMicroButton:ClearAllPoints()
			CharacterMicroButton:SetPoint("BOTTOMLEFT",dvmmframe,"BOTTOMLEFT",27,-1)
		end
	end)

	dvmmframe:SetScript("OnDragStart", dvmmframe.StartMoving) 
	
	dvmmframe:SetScript("OnDragStop", function(self) 
		self:StopMovingOrSizing() 
		self:SetUserPlaced(false) 
		
		point, relativeTo, relativePoint, xOfs, yOfs = self:GetPoint(1)
			if ( relativeTo ) then
				relativeTo = relativeTo:GetName();
			else
				relativeTo = self:GetParent():GetName();
			end
	
		-- These are debugging messages for the frame points
		-- Un-comment them to help debug
		-- DEFAULT_CHAT_FRAME:AddMessage(point)
		-- DEFAULT_CHAT_FRAME:AddMessage(relativeTo)
		-- DEFAULT_CHAT_FRAME:AddMessage(relativePoint)
		-- DEFAULT_CHAT_FRAME:AddMessage(xOfs)
		-- DEFAULT_CHAT_FRAME:AddMessage(yOfs)
		
		private.db.dvdefaults.micromenuSetPoints.point = point
		private.db.dvdefaults.micromenuSetPoints.relativeTo = relativeTo
		private.db.dvdefaults.micromenuSetPoints.relativePoint = relativePoint
		private.db.dvdefaults.micromenuSetPoints.xOffset = xOfs
		private.db.dvdefaults.micromenuSetPoints.yOffset = yOfs		
	end)
	
local dvmmframeFS = dvmmframe:CreateFontString("FontString","OVERLAY","GameTooltipText")
local dvmmFS = dvmmframe:CreateFontString("FontString","OVERLAY","GameTooltipText")

	dvmmFS:SetPoint("CENTER",dvmmframe,"CENTER",0,0)
	dvmmFS:SetFont("Fonts\\FRIZQT__.TTF", 10, "THINOUTLINE")
	dvmmFS:SetText("Micro Menu Buttons");
	dvmmFS:SetTextColor(1, 1, 1);

	local t=dvmmframe:CreateTexture(nil,"ARTWORK")
	t:SetAllPoints(dvmmframe)
	t:SetColorTexture(0, 192, 255, 0.7)
	--DragFrameTemplate(frame,frameGlobalName,frameParentFrame,frameWidth,frameHeight,frameAnchorPoint,frameRelativeTo,frameRelativePoint,frameXoff,frameYoff)

-- Micro Buttons Mouse Fade
local ignoreMMBalpha
local DVMMBAlphaTimer

local function SetAlpha(frame)
	if ignoreMMBalpha then return end
	ignoreMMBalpha = true
	if frame:IsMouseOver() then
		frame:SetAlpha(1)
	else
		frame:SetAlpha(0)
	end
	ignoreMMBalpha = nil
end

local function showMMB(self)
	if DVMMBAlphaTimer then DVMMBAlphaTimer:Cancel() end
    for _, v in ipairs(MICRO_BUTTONS) do
        ignoreMMBalpha = true
        _G[v]:SetAlpha(1)
        ignoreMMBalpha = nil
    end
end
 
local function hideMMB(self)
    for _, v in ipairs(MICRO_BUTTONS) do
        ignoreMMBalpha = true
        _G[v]:SetAlpha(0)
        ignoreMMBalpha = nil
    end
end

local function delayHideMMB(self)
	DVMMBAlphaTimer = C_Timer.NewTimer(0.75, hideMMB)
end

for _, v in ipairs(MICRO_BUTTONS) do
    v = _G[v]
    hooksecurefunc(v, "SetAlpha", SetAlpha)
    v:HookScript("OnEnter", showMMB)
    v:HookScript("OnLeave", delayHideMMB)
	v:SetAlpha(0)
end

-- XP/Rep Bar
StatusTrackingBarManager:SetWidth(476)
-- StatusTrackingBarManager.SingleBarLarge:SetAllPoints(StatusTrackingBarManager)
-- StatusTrackingBarManager.SingleBarLargeUpper:SetAllPoints(StatusTrackingBarManager)

-- local t=StatusTrackingBarManager:CreateTexture(nil,"ARTWORK")
-- 	t:SetAllPoints(StatusTrackingBarManager)
-- 	t:SetColorTexture(0, 192, 255, 0.7)
-- 	t:Show()


-- StatusTrackingBarManager.SingleBarLarge:ClearAllPoints()
-- StatusTrackingBarManager.SingleBarLarge:SetParent(StatusTrackingBarManager)


-- StatusTrackingBarManager.Background:SetAllPoints(StatusTrackingBarManager.SingleBarLarge)
	-- ArtifactWatchBar.StatusBar:SetAllPoints(ArtifactWatchBar)
	-- HonorWatchBar:SetSize(476,6)
	-- HonorWatchBar.StatusBar:SetAllPoints(HonorWatchBar)


-- Move XP Bar Anchor
	-- move(StatusTrackingBarManager,"BOTTOM",MainMenuBar,"BOTTOM",0,0)
	-- move(MainMenuBar,"BOTTOMLEFT",UIParent,"BOTTOMLEFT",0,0)
	-- move(StatusTrackingBarManager.SingleBarLargeUpper,"BOTTOMLEFT",MultiBarBottomLeftButton1,"TOPLEFT",0,0)

local maxlevel = GetMaxPlayerLevel()	
local level = UnitLevel("player")

	--WatchBar Drag frames:
--DragFrameTemplate(WBDrag_ReputationWatchBar,"Reputation(DV Drag Frame)",dvlockcheckframe,476,6)
--DragFrameTemplate(WBDrag_HonorWatchBar,"Honor(DV Drag Frame)",dvlockcheckframe,476,6)

-- SetPoint expects (self,anchorPoint,relativeTo,relativePoint,xoff,yoff)
-- to prevent this hook calling itself, we attach a custom flag at the end
-- so it knows when not to react to the SetPoint.
	-- hooksecurefunc(ReputationWatchBar,"SetPoint",function(self,_,_,_,_,_,flag)
	-- 	if flag~="mbars" then
	-- 		self:ClearAllPoints()
	-- 				self:SetPoint("BOTTOMLEFT",MultiBarBottomLeftButton1,"TOPLEFT",0,0,"mbars")
	-- 				self:SetSize(476,6)
	-- 		StatusTrackingBarManager.SingleBarLargeUpper.WatchBarTexture0:SetAlpha(0);
	-- 		StatusTrackingBarManager.SingleBarLargeUpper.WatchBarTexture1:SetAlpha(0);
	-- 		StatusTrackingBarManager.SingleBarLargeUpper.WatchBarTexture2:SetAlpha(0);
	-- 		StatusTrackingBarManager.SingleBarLargeUpper.WatchBarTexture3:SetAlpha(0);

	-- 		StatusTrackingBarManager.SingleBarLargeUpper.XPBarTexture0:SetAlpha(0);
	-- 		StatusTrackingBarManager.SingleBarLargeUpper.XPBarTexture1:SetAlpha(0);
	-- 		StatusTrackingBarManager.SingleBarLargeUpper.XPBarTexture2:SetAlpha(0);
	-- 		StatusTrackingBarManager.SingleBarLargeUpper.XPBarTexture3:SetAlpha(0);
	-- 	end
	-- end)

	-- hooksecurefunc(HonorWatchBar,"SetPoint",function(self,_,_,_,_,_,flag)
	-- 	if flag~="mbars" then
	-- 		self:ClearAllPoints()
	-- 				self:SetPoint("BOTTOMLEFT",MultiBarBottomLeftButton1,"TOPLEFT",0,0,"mbars")
	-- 				self:SetSize(476,6)
	-- 		HonorWatchBar.StatusBar.WatchBarTexture0:SetAlpha(0);
	-- 		HonorWatchBar.StatusBar.WatchBarTexture1:SetAlpha(0);
	-- 		HonorWatchBar.StatusBar.WatchBarTexture2:SetAlpha(0);
	-- 		HonorWatchBar.StatusBar.WatchBarTexture3:SetAlpha(0);

	-- 		HonorWatchBar.StatusBar.XPBarTexture0:SetAlpha(0);
	-- 		HonorWatchBar.StatusBar.XPBarTexture1:SetAlpha(0);
	-- 		HonorWatchBar.StatusBar.XPBarTexture2:SetAlpha(0);
	-- 		HonorWatchBar.StatusBar.XPBarTexture3:SetAlpha(0);
	-- 	end
	-- end)

	-- hooksecurefunc(ArtifactWatchBar,"SetPoint",function(self,_,_,_,_,_,flag)
	-- 	if flag~="mbars" then
	-- 		self:ClearAllPoints()
	-- 			if level==maxlevel then
	-- 				--DragFrameTemplate(WBDrag_ArtifactWatchBar,"Artifact Power(DV Drag Frame)",dvlockcheckframe,476,6)
	-- 				self:SetPoint("BOTTOMLEFT",ActionButton1,"TOPLEFT",0,0,"mbars")
	-- 				self:SetSize(476,6)
	-- 			else
	-- 				--DragFrameTemplate(WBDrag_ArtifactWatchBar,"Artifact Power(DV Drag Frame)",dvlockcheckframe,476,6)
	-- 				self:SetPoint("BOTTOMLEFT",MultiBarBottomLeftButton1,"TOPLEFT",0,0,"mbars")
	-- 				self:SetSize(476,6)
	-- 			end
	-- 		ArtifactWatchBar.StatusBar.WatchBarTexture0:SetAlpha(0);
	-- 		ArtifactWatchBar.StatusBar.WatchBarTexture1:SetAlpha(0);
	-- 		ArtifactWatchBar.StatusBar.WatchBarTexture2:SetAlpha(0);
	-- 		ArtifactWatchBar.StatusBar.WatchBarTexture3:SetAlpha(0);
			
	-- 		ArtifactWatchBar.StatusBar.XPBarTexture0:SetAlpha(0);
	-- 		ArtifactWatchBar.StatusBar.XPBarTexture1:SetAlpha(0);
	-- 		ArtifactWatchBar.StatusBar.XPBarTexture2:SetAlpha(0);
	-- 		ArtifactWatchBar.StatusBar.XPBarTexture3:SetAlpha(0);
	-- 	end
	-- end)

-- DV Bag Buttons Mouseover Fade
local dvbagframe=CreateFrame("Frame", "dvbagframe", dvlockcheckframe)
	dvbagframe:RegisterEvent("PLAYER_LOGIN")
	dvbagframe:SetFrameStrata("HIGH")
	dvbagframe:SetClampedToScreen(true)
	dvbagframe:SetMovable(true)
	dvbagframe:EnableMouse(true)
	dvbagframe:RegisterForDrag("LeftButton")
	dvbagframe:SetWidth(160)
	dvbagframe:SetHeight(45)
	dvbagframe:Show()

	dvbagframe:SetScript("OnEvent", function(self, event, arg1)
		if event == "PLAYER_LOGIN" then
		local point = private.db.dvdefaults.bagsSetPoints
			self:ClearAllPoints()		
			self:SetPoint(
				point.point, 
				point.relativeTo, 
				point.relativePoint, 
				point.xOffset, 
				point.yOffset)
		end
	end)
	
	dvbagframe:SetScript("OnDragStart", dvbagframe.StartMoving) 
	
	dvbagframe:SetScript("OnDragStop", function(self) 
		self:StopMovingOrSizing() 
		self:SetUserPlaced(false) 
		
		point, relativeTo, relativePoint, xOfs, yOfs = self:GetPoint(1)
			if ( relativeTo ) then
				relativeTo = relativeTo:GetName();
			else
				relativeTo = self:GetParent():GetName();
			end
	
		-- These are debugging messages for the frame points
		-- Un-comment them to help debug
		-- DEFAULT_CHAT_FRAME:AddMessage(point)
		-- DEFAULT_CHAT_FRAME:AddMessage(relativeTo)
		-- DEFAULT_CHAT_FRAME:AddMessage(relativePoint)
		-- DEFAULT_CHAT_FRAME:AddMessage(xOfs)
		-- DEFAULT_CHAT_FRAME:AddMessage(yOfs)
		
		private.db.dvdefaults.bagsSetPoints.point = point
		private.db.dvdefaults.bagsSetPoints.relativeTo = relativeTo
		private.db.dvdefaults.bagsSetPoints.relativePoint = relativePoint
		private.db.dvdefaults.bagsSetPoints.xOffset = xOfs
		private.db.dvdefaults.bagsSetPoints.yOffset = yOfs		
	end)
	
local dvbagframeFS = dvbagframe:CreateFontString("FontString","OVERLAY","GameTooltipText")
local dvbagFS = dvbagframe:CreateFontString("FontString","OVERLAY","GameTooltipText")

	dvbagFS:SetPoint("CENTER",dvbagframe,"CENTER",0,0)
	dvbagFS:SetFont("Fonts\\FRIZQT__.TTF", 10, "THINOUTLINE")
	dvbagFS:SetText("Bags");
	dvbagFS:SetTextColor(1, 1, 1);
	
local t=dvbagframe:CreateTexture(nil,"ARTWORK")
	t:SetAllPoints(dvbagframe)
	t:SetColorTexture(0, 192, 255, 0.7)

BAG_BUTTONS = {
	"MainMenuBarBackpackButton",
	"CharacterBag0Slot",
	"CharacterBag1Slot",
	"CharacterBag2Slot",
	"CharacterBag3Slot",
	}
local ignoreDVBBAlpha
local DVBBAlphaTimer

local function SetAlpha(frame)
	if ignoreDVBBAlpha then return end
	ignoreDVBBAlpha = true
	if frame:IsMouseOver() then
		frame:SetAlpha(1)
	else
		frame:SetAlpha(0)
	end
	ignoreDVBBAlpha = nil
end


local function showDVBB(self)
	if DVBBAlphaTimer then DVBBAlphaTimer:Cancel() end
	for _, v in ipairs(BAG_BUTTONS) do
		ignoreDVBBAlpha = true
		_G[v]:SetAlpha(1)
		ignoreDVBBAlpha = nil
	end
end

local function hideDVBB(self)
	for _, v in ipairs(BAG_BUTTONS) do
		ignoreDVBBAlpha = true
		_G[v]:SetAlpha(0)
		ignoreDVBBAlpha = nil
	end
end

local function delayHideDVBB(self)
	DVBBAlphaTimer = C_Timer.NewTimer(0.75, hideDVBB)
end

MicroButtonAndBagsBar:ClearAllPoints()
MicroButtonAndBagsBar:SetPoint(
	"TOPLEFT", UIParent, "BOTTOMRIGHT", -100, -100)

for _, v in ipairs(BAG_BUTTONS) do
    v = _G[v]
    hooksecurefunc(v, "SetAlpha", SetAlpha)
    v:HookScript("OnEnter", showDVBB)
    v:HookScript("OnLeave", delayHideDVBB)
    v:SetAlpha(0)
end

-- Bag Buttons Init
	MainMenuBarBackpackButton:ClearAllPoints()
	MainMenuBarBackpackButton:SetPoint(
		"BOTTOMRIGHT", dvbagframe, "BOTTOMRIGHT", 0, 0)

local _, private = ...
	private.defaults.dvdefaults.stancebarSetChecked = {
		SetChecked = false,
	}	

local dvstancecheck = CreateFrame("CheckButton", "DejaViewStanceCheck", DejaViewPanel, "InterfaceOptionsCheckButtonTemplate")
	dvstancecheck:RegisterEvent("PLAYER_LOGIN")
	dvstancecheck:ClearAllPoints()
	dvstancecheck:SetPoint("LEFT", 25, -20)
	dvstancecheck:SetScale(1.25)
	dvstancecheck.tooltipText = 'When checked hides the class stance/stealth bar.' --Creates a tooltip on mouseover.
	_G[dvstancecheck:GetName() .. "Text"]:SetText("Hide Stance Bar")

	dvstancecheck:SetScript("OnEvent", function(self, event, arg1)
		if event == "PLAYER_LOGIN" then
		local checked = private.db.dvdefaults.stancebarSetChecked
			self:SetChecked(checked.SetChecked)
			if self:GetChecked(true) then
				dvstanceframe:SetClampedToScreen(false)
				move(dvstanceframe,"TOP", dvlockcheckframe, "BOTTOM", 0, -200)
				private.db.dvdefaults.stancebarSetChecked.SetChecked = true
			else
				dvstanceframe:SetClampedToScreen(true)
				local point = private.db.dvdefaults.stanceSetPoints
					dvstanceframe:ClearAllPoints()		
					dvstanceframe:SetPoint(
						point.point, 
						point.relativeTo, 
						point.relativePoint, 
						point.xOffset, 
						point.yOffset)
				private.db.dvdefaults.stancebarSetChecked.SetChecked = false
			end
		end
	end)
	
	dvstancecheck:SetScript("OnClick", function(self,event,arg1) 
		if self:GetChecked(true) then
			dvstanceframe:SetClampedToScreen(false)
			move(dvstanceframe,"TOP", dvlockcheckframe, "BOTTOM", 0, -200)
			private.db.dvdefaults.stancebarSetChecked.SetChecked = true
		else
			dvstanceframe:SetClampedToScreen(true)
			local point = private.db.dvdefaults.stanceSetPoints
				dvstanceframe:ClearAllPoints()		
				dvstanceframe:SetPoint(
					point.point, 
					point.relativeTo, 
					point.relativePoint, 
					point.xOffset, 
					point.yOffset)
				private.db.dvdefaults.stancebarSetChecked.SetChecked = false
		end
	end)